import numeric.*;

public class Exc0203m02 {
	public static void main(String[] args) {
		EquationSolver solver = new EquationSolver();
		solver.setTolerance(1E-7);
		solver.setNumIterations(100);

		Differentiable g = new DiffAuxFunc();

		new EquationDemoView("Metoda e Newton-it", solver);

		EquationDemoView.setNumSignificantDigits(10);
		
		double x = 0;

		try {
			x = solver.newton(g, 1);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}
		
		Differentiable f = new DiffFunc();

		new EquationDemoView("Metoda e Newton-it", solver);

		try {
			solver.newton(f, x);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}
}

	private static class DiffAuxFunc implements Differentiable {
		public double value(double x) {
			return 2 * x - (1 + x * x) * Math.atan(x);
		}

		public double derivative(double x) {
			return 1 - 2 * Math.atan(x);
		}
	}

	private static class DiffFunc implements Differentiable {
		public double value(double x) {
			return Math.atan(x);
		}

		public double derivative(double x) {
			return 1 / (1 + x * x);
		}
	}
}
