import numeric.*;

public class Exc100210 {
	public static void main(String[] args) {
		double[] initial = { 10, 0.1, 0.1 };
		SystemSolver solver = new SystemSolver(initial.length);

		// Example 10.1.2
		solver.setTolerance(1E-8);
		solver.setNumIterations(20);
		SystemDemoView.setNumSignificantDigits(8);

		PartiallyDifferentiable f = new TestPartiallyDifferentiable();
		new SystemDemoView("Metoda e Newton-it", solver);
		try {
			solver.newton(f, initial);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}

	}

	private static class TestPartiallyDifferentiable implements
			PartiallyDifferentiable {
		public double value(int i, double[] x) {
			double answer = 0;
			switch (i) {
			case 0: {
				answer = x[0] * Math.exp(x[1]) + x[2] - 10;
				break;
			}
			case 1: {
				answer = x[0] * Math.exp(2 * x[1]) + 2 * x[2] - 12;
				break;
			}
			case 2: {
				answer = x[0] * Math.exp(3 * x[1]) + 3 * x[2] - 15;
				break;
			}
			}
			return answer;
		}

		public double partialDerivative(int i, int j, double[] x) {
			double answer = 0;
			switch (i) {
			case 0:
				switch (j) {
				case 0:
					answer = Math.exp(x[1]);
					break;
				case 1:
					answer = x[0] * Math.exp(x[1]);
					break;
				case 2:
					answer = 1;
					break;
				}
				break;
			case 1:
				switch (j) {
				case 0:
					answer = Math.exp(2 * x[1]);
					break;
				case 1:
					answer = 2 * x[0] * Math.exp(2 * x[1]);
					break;
				case 2:
					answer = 2;
					break;
				}
				break;
			case 2:
				switch (j) {
				case 0:
					answer = Math.exp(3 * x[1]);
					break;
				case 1:
					answer = 3 * x[0] * Math.exp(3 * x[1]);
					break;
				case 2:
					answer = 3;
					break;
				}
				break;
			}
			return answer;
		}
	}
}
