import numeric.*;

public class Exm020301 {
	public static void main(String[] args) {
		EquationSolver solverA = new EquationSolver();
		solverA.setTolerance(1E-9);
		solverA.setNumIterations(30);

		EquationSolver solverB = new EquationSolver();
		solverB.setTolerance(1E-10);
		solverB.setNumIterations(7);

		EquationSolver solverC = new EquationSolver();
		solverC.setTolerance(1E-10);
		solverC.setNumIterations(20);

		EquationSolver solverD = new EquationSolver();
		solverD.setTolerance(1E-10);
		solverD.setNumIterations(20);

		Function g = new IterativeFunction();
		Differentiable f = new DiffFunc();

		new EquationDemoView("Metoda e iterimit me pik fikse", solverA);
		new EquationDemoView("Metoda e Newton-it", solverB);
		new EquationDemoView("Metoda e sekants", solverC);
		new EquationDemoView("Metoda Regula Falsi", solverD);

		EquationDemoView.setNumSignificantDigits(10);

		try {
			solverA.fixedPoint(g, Math.PI / 4);
		} catch (Exception e) {
			System.err.println(e.getMessage());
		}

		try {
			solverB.newton(f, Math.PI / 4);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}

		try {
			solverC.secant(f, 0.5, Math.PI / 4);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}

		try {
			solverD.falsi(f, 0.5, Math.PI / 4);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}
}

	private static class IterativeFunction implements Function {
		public double value(double x) {
			return Math.cos(x);
		}
	}

	private static class DiffFunc implements Differentiable {
		public double value(double x) {
			return Math.cos(x) - x;
		}

		public double derivative(double x) {
			return -Math.sin(x) - 1;
		}
	}
}
