/**
 * <p>File: SystemDemoView.java</p>
 * <p>Title: Numerical methods</p>
 * <p>Description: Course on numerical analysis</p>
 * <p>Date: July 2009</p>
 * @author Faton M. Berisha
 * @version 5.0.0
 */

package numeric;

import java.util.*;

/**
 * A demo view for linear system elimination method.
 */
public class LinearSystemEliminationDemoView implements Observer {
//	private static final long serialVersionUID = 4;

	private String frameTitle;

	/**
	 * Constructs demo views with title for linear system elimination method.
	 * 
	 * @param frameTitle
	 *            the title of the frame
	 * @param solver
	 *            the linear system solver
	 */
	public LinearSystemEliminationDemoView(String frameTitle,
			LinearSystemSolver solver) {
		this.frameTitle = frameTitle;

		solver.addMatrixObserver(this);
		solver.addSolutionObserver(this);
	}

	/**
	 * Constructs demo views for linear system elimination method.
	 * 
	 * @param solver
	 *            the linear system solver
	 */
	public LinearSystemEliminationDemoView(LinearSystemSolver solver) {
		this("Metoda e eliminimit", solver);
	}

	public void update(Observable o, Object arg) {
		if (arg instanceof Matrix) {
			new MatrixView(frameTitle, (Matrix) arg);
		}
	}
}
