/**
 * <p>File: MatrixView.java</p>
 * <p>Title: Numerical methods</p>
 * <p>Description: Course on numerical analysis</p>
 * <p>Date: July 2009</p>
 * @author Faton M. Berisha
 * @version 5.0.0
 */

package numeric;

import java.awt.Point;
import javax.swing.*;

public class MatrixView extends AbstractTable {

	private static final long serialVersionUID = 4;

	private static Point frameLocation = new Point();
	private static int offset = 20;

	/**
	 * Constructs matrix view with title.
	 * 
	 * @param frameTitle
	 *            the title of the frame
	 * @param matrix
	 *            the matrix to be viewed
	 */
	public MatrixView(String frameTitle, Matrix matrix) {
		data = new Object[matrix.getNumRows()][matrix.getNumCols()];

		columnHeader = new String[data[0].length];
		for (int i = 0; i < data.length; i++) {
			for (int j = 0; j < data[0].length; j++) {
				data[i][j] = new Double(matrix.get(i, j));
			}
		}

		JTable table = new JTable(this);
		JScrollPane sp = new JScrollPane(table);
		JFrame frame = new JFrame(frameTitle);
		frame.getContentPane().add(sp);
		frame.pack();
		frame.setLocation(frameLocation);
		frameLocation.translate(offset, offset);
		frame.setVisible(true);

		table.setDefaultRenderer(Double.class,
				new AbstractTable.DoubleRenderer());
	}

	/**
	 * Constructs matrix view.
	 * 
	 * @param matrix
	 *            the matrix to be viewed
	 */
	public MatrixView(Matrix matrix) {
		this("Matrica", matrix);
	}

	public Class<?> getColumnClass(int c) {
		return Double.class;
	}

	public int getColumnCount() {
		return data[0].length;
	}

	public int getRowCount() {
		return data.length;
	}

}
