/**
 * <p>File: PartiallyDifferentiable.java</p>
 * <p>Title: Numerical methods</p>
 * <p>Description: Course on numerical analysis</p>
 * <p>Date: July 2009</p>
 * @author Faton M. Berisha
 * @version 5.0.0
 */

package numeric;

/**
 * Interface for a partially differentiable function.
 */
public interface PartiallyDifferentiable extends VectorFunction {
	/**
	 * Returns a value of a partial derivative.
	 * 
	 * @param componentFunction
	 *            coordinate index of the component
	 * @param variable
	 *            coordinate index of the variable
	 * @param x
	 *            the <code>double[]</code> argument
	 * @return the value of the partial derivative
	 */
	double partialDerivative(int componentFunction, int variable, double[] x);
}
